<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>UmlParser xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/java/reverse/umlparser/UmlParser.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.java.reverse.umlparser;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <strong class="jxr_keyword">import</strong> java.io.File;
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">import</strong> java.util.Arrays;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.ast.CompilationUnit;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.JavaParser;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.languages.java.reverse.javaparser.ParseException;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <em class="jxr_javadoccomment"> * @author dumoulin</em>
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/UmlParser.html">UmlParser</a> {
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <em class="jxr_javadoccomment">	 * The visitor used to collect model.</em>
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  	<strong class="jxr_keyword">protected</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/CompilationUnitAnalyser.html">CompilationUnitAnalyser</a> visitor;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/UmlParser.html">UmlParser</a>() {
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  	}
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment">	 * Select the appropriate parsing method according to the file type.</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment">	 * @param file</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment">	 * @throws ParseException</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment">	 * @throws IOException</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> parseResource(File file) <strong class="jxr_keyword">throws</strong> ParseException, IOException {
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  		<strong class="jxr_keyword">if</strong> (file.isDirectory()) {
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  			System.out.println(<span class="jxr_string">"  '"</span> + file.getAbsolutePath() + <span class="jxr_string">" is a directory"</span>);
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  			parsePackage(file);
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  		} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (file.isFile()) {
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  			System.out.println(<span class="jxr_string">"  '"</span> + file.getAbsolutePath() + <span class="jxr_string">" is a file"</span>);
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  			<em class="jxr_comment">// Parse only file ending in .java</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  			<strong class="jxr_keyword">if</strong> (file.getName().endsWith(<span class="jxr_string">".java"</span>)) {
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  				parseFile(file);
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  			} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  				System.out.println(<span class="jxr_string">"skip non java file '"</span> + file.getAbsolutePath() + <span class="jxr_string">"'"</span>);
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  			}
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  			System.out.println(<span class="jxr_string">"  '"</span> + file.getAbsolutePath() + <span class="jxr_string">" can't be identified - "</span> + file);
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  		}
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  	}
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_javadoccomment">	 * Explore the package to call parse on classes</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <em class="jxr_javadoccomment">	 * @param file</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment">	 * @throws ParseException</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  <em class="jxr_javadoccomment">	 * @throws IOException</em>
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> parsePackage(File file) <strong class="jxr_keyword">throws</strong> ParseException, IOException {
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  		<strong class="jxr_keyword">for</strong> (File f : file.listFiles()) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  			parseResource(f);
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  		}
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	}
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">	 * Parse the specified file</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  <em class="jxr_javadoccomment">	 * @param filename</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  <em class="jxr_javadoccomment">	 * @throws IOException</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  <em class="jxr_javadoccomment">	 * @throws ParseException</em>
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> parseFile(File file) <strong class="jxr_keyword">throws</strong> ParseException, IOException {
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  		CompilationUnit cu = JavaParser.parse(file);
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		<em class="jxr_comment">// prints the resulting compilation unit to default system output</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<em class="jxr_comment">// System.out.println(cu.toString());</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  		<em class="jxr_comment">// visitor.visit(cu, null);</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		visitor.processCompilationUnit(cu);
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  	}
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  <em class="jxr_javadoccomment">	 * Select the appropriate parse method according to the type of the</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  <em class="jxr_javadoccomment">	 * resource denoted by the name.</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  <em class="jxr_javadoccomment">	 * @param resourceName</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  <em class="jxr_javadoccomment">	 * @throws IOException</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 * @throws ParseException</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> parseResource(String resourceName) <strong class="jxr_keyword">throws</strong> ParseException, IOException {
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		File file = <strong class="jxr_keyword">new</strong> File(resourceName);
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  		parseResource(file);
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  	}
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> execute(String resourcePath, String outputModelName) <strong class="jxr_keyword">throws</strong> ParseException, IOException {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		System.out.println(<span class="jxr_string">"resource="</span> + resourcePath);
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		<em class="jxr_comment">// Load model</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 		ModelManager modelManager = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/ModelManager.html">ModelManager</a>();
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 		modelManager.createModel(outputModelName);
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 		<em class="jxr_comment">// modelManager.getModel().load(null);</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		<em class="jxr_comment">// Create visitor</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		visitor = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/CompilationUnitAnalyser.html">CompilationUnitAnalyser</a>(modelManager.getModel());
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 		<em class="jxr_comment">// parse all file using the visitor</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		parseResource(resourcePath);
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		<em class="jxr_comment">// Save the model</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 		modelManager.save();
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 	}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> executeTest(String resourcePath, String outputModelName) <strong class="jxr_keyword">throws</strong> ParseException, IOException {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		System.out.println(<span class="jxr_string">"resource="</span> + resourcePath);
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		<em class="jxr_comment">// Load model</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		ModelManager modelManager = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/ModelManager.html">ModelManager</a>();
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		modelManager.createModel(outputModelName);
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		<em class="jxr_comment">// modelManager.getModel().load(null);</em>
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 		<em class="jxr_comment">// Create visitor</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 		String javaccDir = <span class="jxr_string">"H:/temp/papyrus/papyrus-gmf-head2/org.eclipse.papyrus.designer.languages.java.reverse/src/japa/parser"</span>;
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 		String javagenDir = <span class="jxr_string">"H:/temp/papyrus/papyrus-gmf-head2/org.eclipse.papyrus.designer.languages.java.reverse/src/javagen/umlparser"</span>;
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		;
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		String[] paths = {
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 				<span class="jxr_string">"javagen"</span>,
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 				<span class="jxr_string">"javacc"</span>,
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		};
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		visitor = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/CompilationUnitAnalyser.html">CompilationUnitAnalyser</a>(modelManager.getModel(), <span class="jxr_string">"javacc"</span>, <strong class="jxr_keyword">null</strong>, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		<em class="jxr_comment">// parse all file using the visitor</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		parseResource(javaccDir);
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		<em class="jxr_comment">// Second parsing with same model</em>
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 		visitor = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/CompilationUnitAnalyser.html">CompilationUnitAnalyser</a>(modelManager.getModel(), <span class="jxr_string">"javagen"</span>, Arrays.asList(paths), <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 		<em class="jxr_comment">// parse all file using the visitor</em>
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 		parseResource(javagenDir);
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		<em class="jxr_comment">// Save the model</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 		modelManager.save();
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 	}
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">void</strong> main(String args[]) {
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 		<strong class="jxr_keyword">if</strong> (args.length == 1) {
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 				UmlParser p = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/languages/java/reverse/umlparser/UmlParser.html">UmlParser</a>();
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 				p.execute(args[0], <span class="jxr_string">"myfile.uml"</span>);
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 				<em class="jxr_comment">// p.executeTest(args[0], "myfile.uml");</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 			} <strong class="jxr_keyword">catch</strong> (IOException e) {
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 				e.printStackTrace();
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 			} <strong class="jxr_keyword">catch</strong> (ParseException e) {
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 				System.out.println(<span class="jxr_string">"Problems encountered during parsing."</span>);
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 				e.printStackTrace();
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 			}
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 			System.out.println(<span class="jxr_string">"Please select a file or directory to parse"</span>);
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 			<strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		}
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 	}
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 
<a class="jxr_linenumber" name="L166" href="#L166">166</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
